//
//  ViewController.m
//  Convertiseur_ios
//
//  Created by philippe lacomme on 15/11/12.
//  Copyright (c) 2012 Philippe Lacomme. All rights reserved.
//

#import "ViewController.h"

@interface ViewController ()

@end

@implementation ViewController


- (void)viewDidLoad
{
    [super viewDidLoad];
	// Do any additional setup after loading the view, typically from a nib.
}

- (void)didReceiveMemoryWarning
{
    [super didReceiveMemoryWarning];
    // Dispose of any resources that can be recreated.
}

- (void)dealloc {
    [_LaMOrigine release];
    [_LaMDestination release];
    [_LaParite release];
    [super dealloc];
}
- (IBAction)GestionClic:(id)sender {
    [_LaMOrigine resignFirstResponder];
    [_LaMDestination resignFirstResponder];
    [_LaParite resignFirstResponder];
    
    NSString *monnaie_origine = [_LaMOrigine text];
    NSString *monnaie_destination=[_LaMDestination text];
    [_LaParite setText:(NSString *) monnaie_origine];
    
    //appeller le web service
    NSString *soapMessage = [NSString stringWithFormat:
                             @"<?xml version=\"1.0\" encoding=\"utf-8\"?>\n"
                             "<s:Envelope xmlns:s=\"http://schemas.xmlsoap.org/soap/envelope/\">\n"
                             "<s:Body xmlns:xsi=\"http://www.w3.org/2001/XMLSchema-instance\" xmlns:xsd=\"http://www.w3.org/2001/XMLSchema\">\n"
                             "<ConversionRate xmlns=\"http://www.webserviceX.NET/\">\n"
                             "<FromCurrency>%@</FromCurrency>\n"
                             "<ToCurrency>%@</ToCurrency>\n"
                             "</ConversionRate>\n"
                             "</s:Body>\n"
                             "</s:Envelope>\n", monnaie_origine, monnaie_destination];
	
	NSLog(soapMessage);
	NSURL *url = [NSURL URLWithString:@"http://www.webservicex.net/CurrencyConvertor.asmx"];
	NSMutableURLRequest *theRequest = [NSMutableURLRequest requestWithURL:url];
	NSString *msgLength = [NSString stringWithFormat:@"%d", [soapMessage length]];
	
	[theRequest addValue: @"text/xml; charset=utf-8;" forHTTPHeaderField:@"Content-Type"];
	[theRequest addValue: @"\"http://www.webserviceX.NET/ConversionRate\"" forHTTPHeaderField:@"SOAPAction"];
	[theRequest addValue: msgLength forHTTPHeaderField:@"Content-Length"];
	[theRequest setHTTPMethod:@"POST"];

    [theRequest setHTTPBody: [soapMessage dataUsingEncoding:NSUTF8StringEncoding]];
    NSURLConnection *theConnection = [[NSURLConnection alloc] initWithRequest:theRequest delegate:self];
	
    if( theConnection )
    {  _webData=[[NSMutableData data] retain];   }
    else {
        NSLog(@"theConnection is NULL");
    }	

}

-(void)connectionDidFinishLoading:(NSURLConnection *)connection
{
    NSLog(@"DONE. Received Bytes: %d", [_webData length]);
    if( _xmlParser )
        [_xmlParser release];
    _xmlParser = [[NSXMLParser alloc] initWithData: _webData];
    [_xmlParser setDelegate: self];
    [_xmlParser setShouldResolveExternalEntities: YES];
    [_xmlParser parse];
    [connection release];
    [_webData release];
}

-(void)connection:(NSURLConnection *)connection didReceiveResponse:(NSURLResponse *)response
{
    [_webData setLength: 0];
}

-(void)connection:(NSURLConnection *)connection didReceiveData:(NSData *)data
{
    [_webData appendData:data];
    NSLog(@"DONE. Received Bytes: %d", [_webData length]);
    NSString *theXML = [[NSString alloc] initWithBytes: [_webData mutableBytes] length:[_webData length] encoding:NSUTF8StringEncoding];
    NSLog(theXML);
}

-(void)connection:(NSURLConnection *)connection didFailWithError:(NSError *)error
{
    NSLog(@"ERROR with theConkenction");
    [connection release];
    [_webData release];
}

-(void)parser:(NSXMLParser *)parser didStartElement:(NSString *)elementName
 namespaceURI:(NSString *) namespaceURI qualifiedName:(NSString *)qName
   attributes: (NSDictionary *)attributeDict
{
    if( [elementName isEqualToString:@"ConversionRateResult"])
    {
        if(!_soapResults)
            _soapResults = [[NSMutableString alloc] init];
        _xmlResults = YES;
    }
}
-(void)parser:(NSXMLParser *)parser foundCharacters:(NSString *)string
{
    if( _xmlResults )
        [_soapResults appendString: string];
}

-(void)parser:(NSXMLParser *)parser didEndElement:(NSString *)elementName
 namespaceURI:(NSString *)namespaceURI qualifiedName:(NSString *)qName
{
    if( [elementName isEqualToString:@"ConversionRateResult"])
    {
		_xmlResults = FALSE;
		[_LaParite setText:(NSString *)_soapResults];
		[_soapResults release];
		_soapResults = nil;
    }
}


@end
